
<template>
  <div id="list" class="panel">
    <!-- Title, search bar & new item btn  -->
    <span id="title">
      <h4>
        {{ title }}
        <button v-if="refreshBtn" class="reload yellow" @click="getItems">
          &#x21bb;
        </button>
      </h4>
      <input
        type="text"
        placeholder="Search"
        v-model="searchValue"
        @keyup="searchChange"
      />
      <button v-if="newItemAction" @click="newItemAction()">Add new</button>
    </span>

    <!-- Item list -->
    <div id="itemList">
      <p v-if="!items.length && cursor === 0" id="noItemMessage">
        {{ noItemMessage }}
      </p>
      <div
        v-for="(item, index) in items"
        v-bind:key="index"
        class="list-group-item"
      >
        <slot :item="item"></slot>
      </div>
    </div>

    <!-- Next and previous page buttons -->
    <div id="buttons">
      <button
        @click="
          cursor -= itemPerPage;
          getItems();
        "
        :disabled="cursor < itemPerPage"
      >
        Prev
      </button>

      <div id="cursor">
        {{ cursor / itemPerPage + 1 }}
      </div>

      <button
        @click="
          cursor += itemPerPage;
          getItems();
        "
        :disabled="!nexPageAvailable"
      >
        Next
      </button>
    </div>
  </div>
</template>

<script lang="ts">
/**
 * @licence
 * Copyright 2022-2022 - RPG of the Apocalypse
 * Licensed under MIT or any later version
 * Refer to the LICENSE file included.
 */

import { Component, Vue, Prop } from "vue-property-decorator";
import { SearchOptions } from "../../services/backends/index";

@Component
export default class List<T> extends Vue {
  @Prop() gatherFunction!: (searchOptions: SearchOptions) => Promise<T[]>;
  @Prop({ default: 5 }) itemPerPage!: number;
  @Prop({ default: "" }) title!: string;
  @Prop({ default: "This view has no items." }) noItemMessage!: string;
  @Prop({ default: undefined }) newItemAction!: () => void;
  @Prop({ default: "refreshList" }) refreshEventName!: string;
  @Prop({ default: true }) refreshBtn!: boolean;

  cursor = 0;
  items: T[] = [];
  searchValue = "";
  nexPageAvailable = false;
  searchChangeTimeout: number | undefined;

  created(): void {
    this.getItems();

    this.$parent.$on(this.refreshEventName, () => {
      this.getItems();
    });
  }

  async getItems(): Promise<void> {
    // Request items
    // One item is requested in extra to check if a next page is available
    this.items = await this.gatherFunction({
      start: this.cursor,
      end: this.cursor + this.itemPerPage + 1,
      search: this.searchValue === "" ? undefined : this.searchValue
    });

    if (this.items.length > this.itemPerPage) {
      // An extra item has been given so a next page is available
      // Remove extra item
      this.items.pop();
      this.nexPageAvailable = true;
    } else {
      // There is no more items
      this.nexPageAvailable = false;
    }
  }

  searchChange(): void {
    clearTimeout(this.searchChangeTimeout);

    this.searchChangeTimeout = setTimeout(() => {
      this.cursor = 0;
      this.getItems();
    }, 500);
  }
}
</script>

<style scoped>
#list {
  height: 100%;
  display: flex;
  flex-direction: column;
}

#title {
  display: flex;
}
#title h4 {
  flex: 1;
}
#noItemMessage {
  padding: 10px;
  text-align: center;
  opacity: 0.5;
}
#itemList {
  background: black;
  flex: 1;
  margin: 3px;
  overflow-y: auto;
}
#buttons {
  display: flex;
  justify-content: flex-end;
  gap: 10px;
}
</style>
